#include "StdAfx.h"
#include "MMLfile.h"

//==============================================================
//		RXgN^
//--------------------------------------------------------------
//	
//		const char*	strFileName		t@C
//	Ԓl
//				
//==============================================================
MMLfile::MMLfile(const char*	strFileName):
	offset_Ei(0),
	offset_Ev(0),
	offset_En(0),
	offset_Em(0),
	timebase(24),
	octave_reverse(false)
{
	//File open
	nowFile	= new FileInput();

	nowFile->fileopen(strFileName);
	ptcFiles.push_back(nowFile);

	iFiles = 0;
}

//==============================================================
//		fXgN^
//--------------------------------------------------------------
//	
//				
//	Ԓl
//				
//==============================================================
MMLfile::~MMLfile(void)
{

	//----------------------
	//Localϐ
	vector	<FileInput*>::iterator	itFiles;

	//----------------------
	//Delete Class
	itFiles = ptcFiles.begin();
	while(itFiles != ptcFiles.end()){
		(*itFiles)->close();
		delete *itFiles;
		itFiles++;
	}
	ptcFiles.clear();

}

//==============================================================
//		CN[ht@C
//--------------------------------------------------------------
//	
//			
//	Ԓl
//			
//	
//			݂̃t@C|C^ɏĂt@CCN[h
//==============================================================
void	MMLfile::include()
{
	//----------------------
	//Localϐ
	vector	<FileInput*>::iterator	itFiles;
	string	_name = GetString();

	//----------------------
	//t@CJĂȂ`FbN
	itFiles = ptcFiles.begin();
	while(itFiles != ptcFiles.end()){
		if( *(*itFiles)->GetFilename() == _name ){
			Err(L"ɓt@C#includeŊJĂ܂B");
		}
		itFiles++;
	}

	//----------------------
	//File open
	nowFile	= new FileInput();

	nowFile->fileopen(_name.c_str());
	ptcFiles.push_back(nowFile);

	iFiles++; 
}

//==============================================================
//			݃RpC̃t@C|C^̎擾
//--------------------------------------------------------------
//	
//			
//	Ԓl
//			int		݂̃t@C|C^
//==============================================================
int		MMLfile::tellg(void)
{
	return(nowFile->tellg());
}

//==============================================================
//			݃RpC̃t@C|C^𑊑ΓIɈړ
//--------------------------------------------------------------
//	
//			int		ړl
//	Ԓl
//			
//==============================================================
void	MMLfile::StreamPointerAdd(long iSize)
{
	nowFile->StreamPointerAdd(iSize);
}

//==============================================================
//			݃RpC̃t@C|C^ΓIɈړ
//--------------------------------------------------------------
//	
//			int		ړl
//	Ԓl
//			
//==============================================================
void	MMLfile::StreamPointerMove(long iSize)
{
	nowFile->StreamPointerMove(iSize);
}

//==============================================================
//			݃RpC̃t@C|C^߂
//--------------------------------------------------------------
//	
//			int		ړl
//	Ԓl
//			
//==============================================================
void	MMLfile::Back(void)
{
	nowFile->Back();
}

//==============================================================
//			݃RpC̃t@C[EOF]`FbN
//--------------------------------------------------------------
//	
//			
//	Ԓl
//			bool		true	[EOF]o
//						false	܂I肶ȂB
//==============================================================
bool	MMLfile::eof(void)
{
	return( nowFile->eof() );
}

//==============================================================
//			MMLt@C̏I`FbN
//--------------------------------------------------------------
//	
//			
//	Ԓl
//			bool		true	t@C[EOF]o
//						false	܂I肶ȂB
//==============================================================
bool	MMLfile::eom(void)
{
	if(( iFiles == 0 ) && ( eof() )){
		return(true);
	}
	return(false);
}

//==============================================================
//			PByteǂݍ
//--------------------------------------------------------------
//	
//			
//	Ԓl
//			char	ǂݍݒl
//==============================================================
char	MMLfile::cRead(void)
{
	return(nowFile->cRead());
}

//==============================================================
//			PByteǂݍ݁i`FbNtj
//--------------------------------------------------------------
//	
//			
//	Ԓl
//			char	ǂݍݒl
//	
//		P̓ǂݍ݁B
//		AAȉ̋Lqꍇ́A΂B
//			E0x20ȉ̃LN^[R[h
//			ERg
//		܂ACN[ht@C[EOF]oAÕt@Cɖ߂
//==============================================================
char	MMLfile::GetChar(void)		//1Byte̓ǂݍ
{
	unsigned	char	cData;

	do{
		cData = cRead();

		//[EOM]H
		if( eom() )
		{
			return(0);

		//[EOF]H
		} else if( eof() ){
			nowFile->close();
			delete	nowFile;
			ptcFiles.pop_back();
			nowFile = ptcFiles.back();
			iFiles--;
			//continue

		//0x20ȉ̐R[h
		} else if(cData <= 0x20){
			//continue

		//AZu^CṽRgH
		} else if(cData == ';'){
			do{
				cData = cRead();		//̃oCgǂݍ
			} while((cData != 0x0A)||eof());
		
		//b^CṽRgH
		} else 	if(cData == '/'){
			cData = cRead();		//̃oCgǂݍ
			switch(cData){

				//PsRg
				case('/'):
					do{
						cData = cRead();		//̃oCgǂݍ
					}while((cData != 0x0A)||eof());
					break;

				//͈̓Rg
				case('*'):
					do{
						do{
							cData = cRead();		//̃oCgǂݍ
							if(eof()){
								Err(L"RgI[ */ ܂B");
							}
						}while(cData != '*');
						cData = cRead();
						Back();					//StreamPointerAdd(-1);
					} while(cData != '/');
							cRead();			//StreamPointerAdd(+1); B
					break;

				//ȊO
				default:
					Err(L"RgłH");
					break;
			}

		//[EOF]łARgłꍇB
		} else {
			break;		//while(1)  break;
		}

	}while(1);

	return(cData);
}

//==============================================================
//			ǂݍ
//--------------------------------------------------------------
//	
//			
//	Ԓl
//			string	ǂݍ񂾕
//	
//			MML""ň͂܂ꂽ擾B
//==============================================================
string	MMLfile::GetString(void)
{
	char	cData;
	
	string	_str;
	while(cRead() != '"'){
		if(eof()){
			Err(L"Jn\"܂B");
		}
	}

	while('"' != (cData = cRead())){
		if(eof()){
			Err(L"I\"܂B");
		}
		_str += cData;
	}
	return(_str);
}

//==============================================================
//			lǂݍ
//--------------------------------------------------------------
//	
//			
//	Ԓl
//			int		ǂݍ񂾐l
//	
//			MML()ň͂܂ꂽ擾B
//==============================================================
int	MMLfile::GetNum(void)
{
	char	cData;
	int		iResult;

	while(cRead() != '('){
		if(eof()){
			Err(L"lJn(܂B");
		}
	}

	iResult = GetInt();

	while(')' != (cData = cRead())){
		if(eof()){
			Err(L"lI)܂B");
		}
	}
	return(iResult);
}

//==============================================================
//			lǂݍ
//--------------------------------------------------------------
//	
//			
//	Ԓl
//			int		ǂݍ񂾐l
//==============================================================
int		MMLfile::GetInt(void)
{
				bool	neg = false;			//
				int		iResult = 0;			//Z
	unsigned	char	cData = GetChar();

	//16i
	if(cData == '$'){
		cData = cRead();
		if(cData == '+'){
			neg = false;
			cData	 = cRead();
		}
		if(cData == '-'){
			neg = true;
			cData	 = cRead();
		}
		while(((cData >= '0') && (cData <= '9')) || ((cData >= 'a') && (cData <= 'f')) || ((cData >= 'A') && (cData <= 'F'))){
			iResult <<= 4;
			if((cData >= '0') && (cData <= '9')){
				iResult += (unsigned int)cData - 0x30;
			} else if((cData >= 'A') && (cData <= 'F')){
				iResult += (unsigned int)cData - 0x41 + 10;
			} else if((cData >= 'a') && (cData <= 'f')){
				iResult += (unsigned int)cData - 0x61 + 10;
			}
			cData	 = cRead();
		}

	//Qi
	} else if(cData == '%'){
		cData = cRead();
		if(cData == '-'){
			neg = true;
			cData	 = cRead();
		}
		while((cData >= '0') && (cData <= '1')){
			iResult <<= 1;
			iResult += (unsigned int)cData - 0x30;
			cData	 = cRead();
		}

	//10i
	} else if(((cData >= '0') && (cData <= '9')) || (cData == '-') || (cData == '+')){
		if(cData == '+'){
			neg = false;
			cData	 = cRead();
		}
		if(cData == '-'){
			neg = true;
			cData	 = cRead();
		}
		while((cData >= '0') && (cData <= '9')){
			iResult *= 10;
			iResult += (unsigned int)cData - 0x30;
			cData	 = cRead();
		}

	} else {
			Err(L"lȊOw肳܂B");
	}

	//|C^P߂
	Back();							//	StreamPointerAdd(-1);

	//
	if(neg == true){
		iResult = -iResult;
	}

	return(iResult);
}

//==============================================================
//			ǂݍ
//--------------------------------------------------------------
//	
//			
//	Ԓl
//			int		ǂݍ񂾐l
//	
//		ǂݍށit_tj
//==============================================================
int	MMLfile::readLength(unsigned int DefaultLength){

	char	cData;				//ǂݍݗp
	int		iLength;			// [tick]
	int		iDot;				//t_vZp [tick]
	int		iMod;
	int		i;

	//ǂݍ
	cData = GetChar();

	//Length
	if(((cData >= '0') && (cData <= '9')) || (cData == '.')){
		//|C^P߂
		Back();							//StreamPointerAdd(-1);
		if((cData >= '0') && (cData <= '9')){
			i = GetInt();
			iLength = (timebase * 4) / i;
			iMod	= (timebase * 4) % i;
			if(iMod != 0){
				Warning(L"̌vZŊ؂܂łB_͐؎̂Ă܂B");
			}
		} else {
			iLength = DefaultLength;
		}

		iDot	= iLength;
		//t_
		while((cData = cRead()) == '.'){
			iMod = (iDot & 0x01);
			iDot >>= 1;
			if(iMod != 0){
				Warning(L"t_̌vZŊ؂܂łB_͐؎̂Ă܂B");
			}
			iLength += iDot;
		};
		Back();							//StreamPointerAdd(-1);



	//Tick
	} else if (cData == '%'){
		iLength = GetInt();

	} else {
		iLength = -1;
	}

	return(iLength);
}

//==============================================================
//			ǂݍ
//--------------------------------------------------------------
//	
//			
//	Ԓl
//			int		ǂݍ񂾐l
//					ĂȂꍇ́A -1 ԂB
//==============================================================
int		MMLfile::GetLength(unsigned int DefaultLength)	//
{
	char	cData;				//ǂݍݗp
	int		iLength;			// [tick]
	int		iCalc;
	bool	add;

	//ǂݍ
	iLength = readLength(DefaultLength);
	if(iLength == -1){
		return(iLength);
	}

	//̉Z
	cData = cRead();
	while((cData == '+') || (cData == '-')){
		//ŌvZ镄̃`FbN
		if(cData == '+'){
			add = true;
		} else {
			add = false;
		}
		iCalc = readLength(DefaultLength);
		if(iCalc == -1){
			Err(L"̉ZlɐlȊOw肳Ă܂B");
		}
		if(add == true){
			iLength += iCalc;
		} else {
			iLength -= iCalc;
		}
		cData = cRead();
	};
	Back();							//StreamPointerAdd(-1);

	if((iLength < 1) || (iLength > 255)){
		Err(L"́A%1i96j`%255i1+1+2+8j̊ԂŎw肵ĉB255[tick]𒴂ꍇ̓^C`&', `^'gĉB");
	}

	return(iLength);
}

//==============================================================
//		R}hID̎擾
//--------------------------------------------------------------
//	
//		Command_Info*	_command
//		unsigned	int	_size
//	Ԓl
//		int			R}hR[h@i-1unknown commandj
//==============================================================
int	MMLfile::GetCommandID(const Command_Info _command[], unsigned int _size)
{
	unsigned	int		ptCommand	= tellg();	//݂̃t@C|C^ێĂB
	unsigned	int		i			= 0;		//p
	unsigned	int		j;						//`FbNp

	//R}h̃`FbN
	while(i < _size){
		StreamPointerMove(ptCommand);
		j = 0;
		do{
			if(_command[i].str[j] == 0){
				return(_command[i].id);
			}
		} while(cRead() == _command[i].str[j++]);
		i++;
	}
	return(-1);
}

//==============================================================
//		G[
//--------------------------------------------------------------
//	
//				
//	Ԓl
//				
//==============================================================
void	MMLfile::Err(const wchar_t msg[])
{
	//݂̃t@CƁAs\
	cout << "[ ERROR ] " << nowFile->GetFilename()->c_str() << " (Line = " << nowFile->GetLine() << ") : ";

	//G[e\
	wcout << msg << endl;

	//ُI
	exit(-1);
}

//==============================================================
//		[jO
//--------------------------------------------------------------
//	
//				
//	Ԓl
//				
//==============================================================
void	MMLfile::Warning(const wchar_t msg[])
{
	//݂̃t@CƁAs\
	cout << "[WARNING] " << nowFile->GetFilename()->c_str() << " (Line = " << nowFile->GetLine() << ") : ";

	//[jOe\
	wcout << msg << endl;
}
